<template>
  <div class="w-100 max-w-5xl flex flex-col items-center mx-auto py-8">
    <nav class="flex w-full justify-between font-medium items-baseline">
      <span class="text-2xl w-1/3 flex flex-row">Timer: {{ timer.value }}s</span>
      <h1 class="text-4xl font-bold w-1/3 text-center">
        <a href="/" class="transition hover:text-underline hover:text-green-700" title="Clicca per ricaricare">
          Esercizio Vue
        </a>
      </h1>
      <span class="text-2xl w-1/3 flex flex-row justify-end">Peso massimo: {{ maxWeight }}KG</span>
    </nav>

    <span class="text-2xl my-16">Peso totale: {{ totalWeight }}KG</span>

    <div class="flex justify-between w-full">
      <div v-for="water in waters" :key="water" class="flex flex-col items-center">
        <div class="relative flex flex-col items-center">
          <div class="w-72 h-20 bg-green-700 opacity-60"></div>
          <div class="w-40 h-96 bg-green-700 opacity-60"></div>
          <div
            class="w-40 bg-blue-400 absolute bottom-0 transition-all"
            :style="{ height: water.level * heightMultiplier + 'px' }">
          </div>
          <div
            @click="water.stopWeight = true"
            class="w-20 h-12 bg-stone-700 absolute transition-all text-white flex justify-center items-center cursor-pointer"
            :style="{ bottom: water.boxLevel * heightMultiplier + 'px' }"
          >
            {{ water.boxWeight.toFixed(1) }}KG
          </div>
        </div>
        <span class="text-xl">Livello: {{ (water.level / maxWaterLevel * 100).toFixed(1) }}%</span>
      </div>
    </div>

    <Popup v-if="endCondition" :totalWeight="totalWeight" :maxWeight="maxWeight" :timeRemaining="timer.value" :condition="endCondition" />

  </div>
</template>

<script>
import Popup from './Popup';

export default {
  name: 'Game',

  components: { Popup },

  data () {
    return {
      waters: [
        {
          level: 0,
          increase: this.randomNumber(1, 5),
          interval: null,
          boxWeight: this.randomNumber(2, 4),
          boxLevel: 0,
          stopWeight: false
        },
        {
          level: 0,
          increase: this.randomNumber(1, 5),
          interval: null,
          boxWeight: this.randomNumber(2, 4),
          boxLevel: 0,
          stopWeight: false
        },
        {
          level: 0,
          increase: this.randomNumber(1, 5),
          interval: null,
          boxWeight: this.randomNumber(2, 4),
          boxLevel: 0,
          stopWeight: false
        }
      ],
      timer: {
        value: this.randomNumber(30, 60),
        interval: null
      },
      heightMultiplier: 4,
      maxWeight: this.randomNumber(30, 45),
      maxWaterLevel: 116,
      endCondition: ''
    }
  },

  computed: {
    totalWeight () {
      let total = 0;
      this.waters.forEach(water => {
        total += water.boxWeight;
      });
      this.checkWeights(total);
      return total.toFixed(1);
    }
  },

  mounted () {
    this.increaseWatersLevel();
    this.handleTimer();
  },

  methods: {
    randomNumber (min, max) {
      return Math.floor(Math.random() * (max - min + 1) + min);
    },

    increaseWatersLevel () {
      this.waters.forEach(water => {
        water.interval = setInterval(() => {
          if (water.level + water.increase <= this.maxWaterLevel) {
            water.level += water.increase;
            if (!water.stopWeight) {
              water.boxLevel += water.increase;
              water.boxWeight += water.increase / 10
            } else {
              this.checkWeights();
            }
          } else {
            water.level = this.maxWaterLevel;
            this.endGame('Hai perso! L\'acqua ha raggiunto il livello massimo');
          }
        }, this.randomNumber(500, 2000));
      });
    },

    handleTimer () {
      this.timer.interval = setInterval(() => {
        if (this.timer.value > 0) {
          this.timer.value--;
        } else {
          this.endGame('Hai perso! Tempo scaduto');
        }
      }, 1000);
    },

    checkWeights (total) {
      if (total >= this.maxWeight) {
        this.endGame('Hai perso! Peso massimo raggiunto');
      }
      let allWeightsStopped = true;
      this.waters.forEach(water => {
        !water.stopWeight ? allWeightsStopped = false : '';
      });
      allWeightsStopped ? this.endGame('Hai fermato tutti i pesi') : '';
    },

    endGame (condition) {
      clearInterval(this.timer.interval);
      this.waters.forEach(water => {
        clearInterval(water.interval);
      });
      this.endCondition = condition;
    }
  }

}
</script>
